﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Services;
using Common;
using EntityModel;
using System.Data.Entity;
using MvcPaging;

namespace Heart.Controllers
{
    public class BrandController : Controller
    {
        #region 公用属性
        private BrandService brandService = new BrandService();
        ShopDbEntities bdContext = DbContextHelper.GetCurrentDbContext();
        private int pageSize = ConfigHelper.PageSize();
        #endregion
        //
        // GET: /Brand/

        public ActionResult Index(int? page)
        {
            int PageIndex = page.HasValue ? (page.Value == 0 ? 0 : (page.Value - 1)) : 0;
            var list = brandService.GetAllList().ToPagedList(PageIndex, pageSize);
            return View(list);
        }
        public ActionResult Create()
        {
            IEnumerable<Brand> list = brandService.GetList();
            ViewData["list"] = new SelectList(list, "Id", "Name");
            return View();
        }
        [HttpPost]
        public ActionResult Create(FormCollection model)
        {
            HttpPostedFileBase file = Request.Files["LogoUrl"];
            string categoryPath = "";
            //存入文件
            if (file.ContentLength > 0)
            {
                categoryPath = Server.MapPath("~/upload/brand/");
                file.SaveAs(categoryPath + System.IO.Path.GetFileName(file.FileName));
            }
            Brand c = new Brand();
            c.Name = WebBase.GetForm("Name");
            c.Status = (int)EnumModel.Status.Show;
            c.MetaKeywords = WebBase.GetForm("MetaKeywords");
            c.DisplayOrder = WebBase.GetFormInt("DisplayOrder");
            c.MetaDescription = WebBase.GetForm("MetaDescription");
            c.LogoUrl = file.FileName;
            brandService.Create(c);
            return RedirectToAction("Index");
        }



    }
}
