﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Services;
using Common;
using EntityModel;
using System.Data.Entity;
using MvcPaging;

namespace Heart.Controllers
{
    public class CategoryController : Controller
    {
        #region 公用属性
        private CategoryService categoryService = new CategoryService();
        private int pageSize = ConfigHelper.PageSize();
        #endregion
        //
        // GET: /Category/

        public ActionResult Index(int? page)
        {
            int PageIndex = page.HasValue ? (page.Value == 0 ? 0 : (page.Value - 1)) : 0;
            var list = categoryService.GetAllList().ToPagedList(PageIndex, pageSize);
            return View(list);
        }

        public ActionResult Create()
        {
            IEnumerable<Category> list = categoryService.GetList();
            ViewData["list"] = new SelectList(list, "Id", "Name");
            return View();
        }
        [HttpPost]
        public ActionResult Create(FormCollection model)
        {
            HttpPostedFileBase file = Request.Files["PictureUrl"];
            string categoryPath = "";
            //存入文件
            if (file.ContentLength > 0)
            {
                categoryPath = Server.MapPath("~/upload/category/");
                file.SaveAs(categoryPath + System.IO.Path.GetFileName(file.FileName));
            }
            Category c = new Category();
            c.Name = WebBase.GetForm("Name");
            c.Status = (int)EnumModel.Status.Show;
            c.MetaKeywords = WebBase.GetForm("MetaKeywords");
            c.DisplayOrder = WebBase.GetFormInt("DisplayOrder");
            c.MetaDescription = WebBase.GetForm("MetaDescription");
            c.ParentCategoryId = WebBase.GetFormInt("ParentCategoryId");
            c.PictureUrl = file.FileName;
            categoryService.Create(c);
            return RedirectToAction("Index");
        }




    }
}
