﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EntityModel;
using Common;

namespace Services
{
    public class ArticleTypeService
    {
        #region***属性数据***

        ShopDbEntities bdContext = DbContextHelper.GetCurrentDbContext();


        #endregion

        #region 获取所有分类

        /// <summary>
        /// 获取所有文章分类
        /// </summary>
        /// <returns></returns>
        ///  PagedList<Category>
        ///  
        public IQueryable<ArticleType> GetAllList()
        {

            return bdContext.ArticleTypes.OrderByDescending(c => c.Id);
        }

        #endregion

        #region 获取所有文章分类

        /// <summary>
        /// 获取所有显示文章分类
        /// </summary>
        /// <returns></returns>
        public IEnumerable<ArticleType> GetList()
        {
            return bdContext.ArticleTypes.Where(c => c.Status == (int)EnumModel.Status.Show).OrderByDescending(c => c.DisplayOrder);
        }
        #endregion

        #region 新增数据

        public void Create(ArticleType model)
        {
            bdContext.ArticleTypes.AddObject(model);
            bdContext.SaveChanges();
        }
        #endregion
    }
}
